;*********************************************************************************************************
;**********	Anzeigeroutinen zum Tapetimer Version 2.1					**********
;*********************************************************************************************************

;*********************************************************************************************************
;**********	anzeige lschen									**********
;**********	benutzte Register: anzeige[4:0]							**********
;*********************************************************************************************************
loesche_anzeige:
	sts	anzeige,null		;
	sts	anzeige+1,null		;
	sts	anzeige+2,null		;
	sts	anzeige+3,null		;
	sts	anzeige+4,null		;
	ret

;*********************************************************************************************************
;**********	Zeichenfolge "FE-N" in den anzeige schreiben. N = Fehlercode			**********
;**********	benutzte Register: var1[1:0], anzeige[4:0], Z, blinkermaske			**********
;*********************************************************************************************************
zeige_fehlercode:
	ldi	var10,zeichen_F		;lade "FE-"
	sts	anzeige+1,var10		;
	ldi	var10,zeichen_E		;
	sts	anzeige+2,var10		;
	ldi	var10,zeichen_minus	;
	sts	anzeige+3,var10	;
	lds	var10,fehleranzeige	;hole Fehlernummer
	rcall	hole_leuchtbild		;Leuchtbild holen
	sts	anzeige+4,var10		;
	ldi	var10,alle_digits	;
	sts	blinkermaske,var10	;alle Anzeigestellen blinken
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Blinkendes "P_Optionszahl-Status" anzeigen					**********
;**********	benutzte Register:								**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z, blinkermaske			**********
;*********************************************************************************************************
zeige_menue:
	sts	anzeige,null		;
	ldi	var10,zeichen_p		;
	sts	anzeige+1,var10		;" P" eintasten

	mov	var10,flags3		;sichere Register
	andi	var10,alle_menuebits	;Menbits maskieren
	mov	var12,var10		;Kopie herstellen
	rcall	bin2bcd8		;in gepacktes BCD wandeln (zerstrt var10 und var11)
	rcall	hole_leuchtbild		;nur Einerstelle holen
	sts	anzeige+2,var10		;"Mennummer" eintasten	
	ldi	var10,zeichen_minus	;
	sts	anzeige+3,var10		;"-" eintasten
	ldi	var10,zeichen_a		;ein "A" vorhalten

	cpi	var12,1			;
	breq	option_1		;in die entsprechenden Menpunkte verzweigen
	cpi	var12,2			;
	breq	option_2		;
	cpi	var12,3			;
	breq	option_3		;
	cpi	var12,4			;
	breq	option_4		;
	cpi	var12,5			;
	breq	option_5		;
	cpi	var12,6			;
	breq	option_6		;
	cpi	var12,7			;
	breq	option_7		;
	cpi	var12,8			;die 8 ist noch
	breq	option_8		;ohne hinterlegte Funktion
	cpi	var12,9			;
	breq	option_9		;
	cpi	var12,10		;
	breq	option_10		;
	cpi	var12,11		;
	breq	option_11		;
	rjmp	ende_displaybild	;ungltige Menpunkte abfangen
option_1:
	sbrc	flags2,0		;wenn die Option gesetzt ist
	ldi	var10,zeichen_e		;ein "E" fr die Anzeige vorhalten
	rjmp	setze_statusbild	;
option_2:
	sbrc	flags2,1		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_3:
	sbrc	flags2,2		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_4:
	sbrc	flags2,3		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_5:
	sbrc	flags2,4		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_6:
	sbrc	flags2,5		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_7:
	sbrc	flags2,6		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_8:
	sbrc	flags2,7		;
	ldi	var10,zeichen_e		;
	rjmp	setze_statusbild	;
option_9:
	lds	var10,hell_index	;
	clr	var11			;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	rcall	behandle_nullen		;
	ldi	var10,zeichen_c		;ein "c" einblenden
	sts	anzeige+1,var10	;
	ldi	var10,(1<<a_digit3)|(1<<a_digit4)|(1<<a_digit5)
	sts	blinkermaske,var10	;die einstellbaren Ziffern blinken
	rjmp	ende_displaybild	;
option_10:
	lds	var10,karussell		;
	inc	var10			;Offset
	clr	var11			;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	rcall	behandle_nullen		;
	ldi	var10,(1<<Seg_a)|(1<<Seg_d)|(1<<Seg_g)	;links ein halbes "E" einblenden
	sts	anzeige+1,var10	;
	ldi	var10,(1<<a_digit4)|(1<<a_digit5)
	sts	blinkermaske,var10	;die 2 rechten Anzeigestellen blinken
	rjmp	ende_displaybild	;
option_11:
	lds	var10,stunden_anz	;
	lds	var11,stunden_anz+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	rcall	behandle_nullen		;
	ldi	var10,alle_digits	;
	sts	blinkermaske,var10	;alle Anzeigestellen blinken
	rjmp	ende_displaybild	;
setze_statusbild:
	sts	anzeige+4,var10	;
	ldi	var10,(1<<a_digit5)	;
	sts	blinkermaske,var10	;die letzte Anzeigetelle blinkt
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "STUNDEN:MINUTEN:SEKUNDEN" in anzeige schreiben			**********
;**********	benutzte Register: var1[2:0], var2[1:0], anzeige[4:0], tBCD[2:0], Z		**********
;*********************************************************************************************************
zeige_zeit:
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_minuten_symb	;kurz einen Kennbuchstaben zeigen
	lds	var10,Zeit_quartz	;hole quarzgenaue Sekundenlaufzeit
	lds	var11,Zeit_quartz+1	;
	rcall	sek2min2BCD		;wandle ins Format Std/Min/Sek bzw Min/Sek und lege als gepacktes BCD ab
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen

	sbrs	flags1,resync		;nach erfolgter Nachsynchronisation
	rjmp	zeit_punkt		;
	clr	var10			;Dezimalpunkte
	lds	var11,blinker		;
	sbrs	var11,4			;alle 2^4 Frames blinken lassen
zeit_punkt:
.if (anzeigestellen==4)			;bei 4 Digits
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	ldi	var10,(1<<1)|(1<<3)	;Dezimalpunkte  -.--.-- eintasten
.endif
	rcall	setze_dezimalpunkte	;setzen
	rjmp	ende_displaybild	;
zeige_minuten_symb:
	rcall	loesche_anzeige		;
	ldi	var10,zeichen_t_kl	;
.if (anzeigestellen==4)			;bei 4 Digits
	sts	anzeige+1,var10		;"t" eintasten
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	sts	anzeige,var10		;"t" eintasten
.endif
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "b BANDDICKE" in anzeige schreiben					**********
;**********	benutzte Register: dicke_neu,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_dicke_0:
	ldi	var12,zeichen_b_kl	;Kennbuchstabe "b" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_dicke_neu_symb	;kurz einen Kennbuchstaben zeigen
.endif
	sbrc	flags1,dicke_valide	;wenn keine gltigen Werte einlaufen
	rjmp	dicke_gueltig		;
	rcall	zeige_fast_leer		;"---.--" anzeigen
	rjmp	dicke_ungueltig		;
dicke_gueltig:
	lds	var10,dicke_roh		;hole letzten gerechneten, ungefilterten Banddickewert
	lds	var11,dicke_roh+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
	rcall	setze_dezimalpunkte	;setzen
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
dicke_ungueltig:	
	sts	anzeige,var12		;links noch das Zeichen "b" eintasten
	rjmp	ende_displaybild	;
zeige_dicke_neu_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;"b" eintasten
	rjmp	ende_displaybild	;
	
;*********************************************************************************************************
;**********	Zeichenfolge " BANDDICKE" mit Zehntel in anzeige schreiben			**********
;**********	benutzte Register: dicke,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_dicke_3:
	ldi	var12,zeichen_u_kl	;Kennbuchstaben "u" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_dicke_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,dicke+2		;hole Dickenwert Ganzzahlanteil
	lds	var11,dicke+3		;
.if (anzeigestellen==4)			;nur bei 4 Digits
	subi	var10,byte1(-5)		;zwecks Rundung auf nur eine Nachkommastelle
	sbci	var11,byte2(-5)		;0,05 addieren
.endif
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
	rcall	setze_dezimalpunkte	;setzen
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,anzeige+4		;letztes Digit holen
	andi	var10,(1<<seg_dp)	;alle Segmente ausser Dezimalpunkt lschen	
	sts	anzeige+4,var12		;
.endif
	rjmp	ende_displaybild	;
zeige_dicke_symb:
	rcall	loesche_anzeige		;
	ldi	var10,zeichen_mikro	;
	sts	anzeige+1,var10		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge " BANDDICKE" mit Hundertstel in anzeige schreiben			**********
;**********	benutzte Register: dicke,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_dicke_4:
	ldi	var12,zeichen_mikro	;Kennbuchstaben "" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_dicke_4_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,dicke+2		;hole Dickenwert
	lds	var11,dicke+3		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
	rcall	setze_dezimalpunkte	;setzen
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_dicke_4_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "A BANDDICKE", Ableitung der Banddicke ber 1 Feld			**********
;**********	in nm mit 2 Nachkommastellen in den anzeige schreiben				**********
;**********	benutzte Register: dicke, dicke_alt						**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_dicke_delta:
	ldi	var12,zeichen_A		;Kennbuchstaben "A" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_dicke_delta_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,dicke_delta_anz	;hole Ableitung Dickenwert
	lds	var11,dicke_delta_anz+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
	rcall	setze_dezimalpunkte	;setzen
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	sbrs	flags1,dicke_negativ	;wenn "dicke_delta" positiv
	rjmp	ende_displaybild	;kein Minuszeichen eintasten
;*******  Behandlung Eintastung Minuszeichen  ************************************************************
	lds	var10,anzeige+1		;
	tst	var10			;wenn digit+1 = leer (bei aktiver Nullunterdrckung)
	breq	dicke_delta_negativ	;
	cpi	var10,zeichen_0		;oder digit+1 = zeichen_0 (bei deaktiver Nullunterdrckung)
	breq	dicke_delta_negativ	;
	rjmp	ende_displaybild	;
dicke_delta_negativ:
	ldi	var10,zeichen_minus	;
	sts	anzeige+1,var10		;taste auf digit+1 ein Minuszeichen ein
	rjmp	ende_displaybild	;
zeige_dicke_delta_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "I FILTERINDEX" in anzeige schreiben				**********
;**********	benutzte Register: filterindex							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_filterindex:
	ldi	var12,zeichen_I		;Kennbuchstaben "I" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_filterindex_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,filterindex	;lade Filterindex
	clr	var11			;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten					
	rjmp	ende_displaybild	;
zeige_filterindex_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "U UMDREHUNGEN" in anzeige schreiben				**********
;**********	benutzte Register:								**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_umdrehungen:
	ldi	var12,zeichen_U		;Kennbuchstaben "U" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_umdrehung_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,umdrehungszahl	;hole Umdrehungszhler
	lds	var11,umdrehungszahl+1	;

	lsr	var11			;dividiere durch 2*Zebra
	ror	var10			;(Nachkommaanteil entfernen)
	lsr	var11			;
	ror	var10			;
	lsr	var11			;
	ror	var10			;
.if (zebra==8)
	lsr	var11			;
	ror	var10			;
.endif
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_umdrehung_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "L BANDLAGEN" in anzeige schreiben					**********
;**********	benutzte Register: lagen,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_bandlagen:
	ldi	var12,zeichen_L		;Kennbuchstaben "L" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_lagen_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,lagenzahl		;hole Bandlagenzhler
	lds	var11,lagenzahl+1	;

	lsr	var11			;dividiere durch 2*Zebra
	ror	var10			;(Nachkommaanteil entfernen)
	lsr	var11			;
	ror	var10			;
	lsr	var11			;
	ror	var10			;
.if (zebra==8)
	lsr	var11			;
	ror	var10			;
.endif
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_lagen_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "S.SEKUNDEN" in anzeige schreiben					**********
;**********	benutzte Register: zeit_calc,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_sekunden:
	ldi	var12,zeichen_S|zeichen_punkt;Kennbuchstaben "S." vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_sekunden_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,Zeit_calc		;hole errechnete Sekundenlaufzeit
	lds	var11,Zeit_calc+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_sekunden_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "E FEHLER" in Anzeige schreiben					**********
;**********	Der betragsmige Unterschied in gerechneten und gezhlten Sekunden		**********
;**********	wird mit Vorzeichen angezeigt							**********
;**********	Bei Trimmung in Richtung schneller wird ein Oberstrich, in Richtung langsamer	**********
;**********	ein Unterstrich auf dem linken Digit eingetastet.				**********
;**********	benutzte Register: zeit_calc, zeit_anz,						**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_sekundenfehler:
	ldi	var12,zeichen_E		;Kennbuchstaben "E" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_sekundenfehler_symb;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,zeit_delta	;hole Differenz errechnete zu angezeigten Sekunden
	lds	var11,zeit_delta+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	sts	anzeige+1,null		;" " eintasten
	sbrs	flags1,zeit_negativ	;bei negativem Anzeigewert
	rjmp	ende_e_minuszeichen	;
	ldi	var10,zeichen_minus	;Minuszeichen vorhalten
	sbrs	flags2,nullunterdr	;
	rjmp	e_2_minus		;und ohne Nullunterdrckung auf Digit 2 schreiben, sonst
;**********	Minuszeichen rechtsbndig schreiben ******************************************************
	lds	var11,anzeige+2		;teste Digit 3 auf "blank"
	tst	var11			;
	brne	e_2_minus		;
	lds	var11,anzeige+3		;teste Digit 4 auf "blank"
	tst	var11			;
	brne	e_3_minus		;
;e_4_minus:
	sts	anzeige+3,var10		;"-" eintasten
	rjmp	ende_e_minuszeichen	;
e_3_minus:
	sts	anzeige+2,var10		;"-" eintasten
	rjmp	ende_e_minuszeichen	;
e_2_minus:
	sts	anzeige+1,var10		;"-" eintasten
ende_e_minuszeichen:
	lds	var11,trimmanzeige	;lade Symbol fr Trimmrichtung Framezhler und
	lds	var10,anzeige+1		;
	or	var10,var11		;taste das zu einem evtl. vorhandenen Minuszeichen auf Digit 2 ein
	sts	anzeige+1,var10		;	
	rjmp	ende_displaybild
zeige_sekundenfehler_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "J LETZTE SEGMENTLAUFZEIT" in anzeige schreiben			**********
;**********	benutzte Register: var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z		**********
;*********************************************************************************************************
zeige_segmentlaufzeit:
	ldi	var12,zeichen_J		;Kennbuchstaben "J" vorhalten
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_segment_akt_symb	;kurz einen Kennbuchstaben zeigen
	lds	var10,t_segm_akt	;hole Wert
	lds	var11,t_segm_akt+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	rjmp	ende_displaybild	;
zeige_segment_akt_symb:
	rcall	loesche_anzeige		;
.if (anzeigestellen==4)			;bei 4 Digits
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	sts	anzeige,var12		;Kennbuchstaben eintasten
.endif
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "n MITTELWERT" Segmentlaufzeit aktuell				**********
;**********	in anzeige schreiben								**********
;**********	benutzte Register:								**********
;**********	t_segm, var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z			**********
;*********************************************************************************************************
zeige_drehzahl:
	ldi	var12,zeichen_n_kl	;Kennbuchstaben "n" vorhalten
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_drehzahl_symb	;kurz einen Kennbuchstaben zeigen
	lds	var10,t_segm		;hole Wert
	lds	var11,t_segm+1		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	rjmp	ende_displaybild	;
zeige_drehzahl_symb:
	rcall	loesche_anzeige		;
.if (anzeigestellen==4)			;bei 4 Digits
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	sts	anzeige,var12		;Kennbuchstaben eintasten
.endif
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "N MITTELWERT" Segmentlaufzeit alt					**********
;**********	in anzeige schreiben								**********
;**********	benutzte Register:								**********
;**********	t_segm_delta, var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z			**********
;*********************************************************************************************************
zeige_drehzahl_delta:
	ldi	var12,zeichen_N		;Kennbuchstaben "N" vorhalten
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_drehzahl_delta_symb;kurz einen Kennbuchstaben zeigen
	lds	var10,t_segm_delta	;hole Wert
	lds	var11,t_segm_delta+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	rjmp	ende_displaybild
zeige_drehzahl_delta_symb:
	rcall	loesche_anzeige		;
.if (anzeigestellen==4)			;bei 4 Digits
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	sts	anzeige,var12		;Kennbuchstaben eintasten
.endif
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "o KERNRADIUS" in anzeige schreiben				**********
;**********	benutzte Register: kernradius,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_kernradius:
	ldi	var12,zeichen_o_kl	;Kennbuchstaben "o" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_kernradius_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var20,kernradius	;lade Kernradius
	lds	var21,kernradius+1	;
	lds	var22,kernradius+2	;

	subi	var20,byte1(-100)	;runden
	sbci	var21,byte2(-100)	;
	sbci	var22,byte3(-100)	;

	ldi	var10,byte1(16777)	;lade Multiplikator
	ldi	var11,byte2(16777)	;K = 2^24/1000

	rcall	mul16x24u		;

	mov	var10,mod3		;sichere den 2^24sten Teil
	mov	var11,mod4		;

	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
	rcall	setze_dezimalpunkte	;setzen
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_kernradius_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "r WICKELRADIUS" in anzeige schreiben				**********
;**********	benutzte Register: radius,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_wickelradius:
	ldi	var12,zeichen_r_kl	;Kennbuchstaben "r" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_radius_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,wickelradius	;lade Wickelradius
	lds	var11,wickelradius+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<3)		;Dezimalpunkt ---.--
	rcall	setze_dezimalpunkte	;setzen
	rcall	behandle_nullen		;
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_radius_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "F SYNCFENSTER" in anzeige schreiben				**********
;**********	benutzte Register: syncfenster,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_syncfenster:
	ldi	var12,zeichen_F		;Kennbuchstaben "F" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_sync_symb		;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,syncfenster	;hole Syncfensterzhler
	lds	var11,syncfenster+1	;

	lsr	var11			;dividiere durch 2*Zebra
	ror	var10			;
	lsr	var11			;
	ror	var10			;
	lsr	var11			;
	ror	var10			;
.if (zebra==8)
	lsr	var11			;
	ror	var10			;
.endif
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_sync_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "H GESAMTKOPFSTUNDEN" in anzeige schreiben				**********
;**********	benutzte Register: stunden_anz,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_kopfstunden:
	ldi	var12,zeichen_H		;Kennbuchstaben "H" vorhalten
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_stunden_symb	;kurz einen Kennbuchstaben zeigen
	lds	var10,stunden_anz	;lade Stundenanzeige
	lds	var11,stunden_anz+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	rjmp	ende_displaybild	;
zeige_stunden_symb:
	rcall	loesche_anzeige		;
.if (anzeigestellen==4)			;bei 4 Digits
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	sts	anzeige,var12		;Kennbuchstaben eintasten
.endif
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "h KOPFSTUNDEN" rcksetzbar in anzeige schreiben			**********
;**********	benutzte Register: stunden_anz,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_kopfstunden_r:
	ldi	var12,zeichen_h_kl	;Kennbuchstaben "h" vorhalten
.if (anzeigestellen==4)			;nur bei 4 Digits
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_stunden_r_symb	;kurz einen Kennbuchstaben zeigen
.endif
	lds	var10,stunden_r_anz	;lade Stundenanzeige
	lds	var11,stunden_r_anz+1	;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	ldi	var10,(1<<4)		;Dezimalpunkt ----.-
	sbrs	flags2,stunden_zehntel	;
	clr	var10			;
	rcall	setze_dezimalpunkte	;setzen
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	sts	anzeige,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;
zeige_stunden_r_symb:
	rcall	loesche_anzeige		;
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "D MESSWERT" in anzeige schreiben					**********
;**********	benutzte Register: debug,							**********
;**********	var1[2:0], var2[2:0], anzeige[4:0], tBCD[2:0], Z				**********
;*********************************************************************************************************
zeige_debug:
	ldi	var12,zeichen_d_kl	;Kennbuchstaben "d" vorhalten
	lds	var10,kennung		;
	cpi	var10,dauer_kennung	;nach dem Anzeigewechsel zunchst
	brlo	zeige_debug_symb	;kurz einen Kennbuchstaben zeigen
	lds	var10,debug		;hole Debug-Wert
	lds	var11,debug+1		;
	rcall	bin2bcd16		;Umwandlung 16 Bit Binrzahl in 5-stelliges gepacktes BCD
	rcall	bcd2digit		;gepacktes BCD in 5 stelliges Leuchtzeichen umformen und ablegen
	clr	var10			;keine Dezimalpunkte
	rcall	setze_dezimalpunkte	;
	rcall	behandle_nullen		;fhrende Nullen nach Option behandeln
	rjmp	ende_displaybild	;
zeige_debug_symb:
	rcall	loesche_anzeige		;anzeige lschen
.if (anzeigestellen==4)			;bei 4 Digits
	sts	anzeige+1,var12		;Kennbuchstaben eintasten
.endif
.if (anzeigestellen==5)			;bei 5 Digits
	sts	anzeige,var12		;Kennbuchstaben eintasten
.endif
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "CASS" in anzeige schreiben					**********
;**********	benutzte Register: var1[1:0], anzeige[4:0]					**********
;*********************************************************************************************************
zeige_cass:
	sts	anzeige,null		;" " eintasten
	ldi	var10,zeichen_C		;	
	sts	anzeige+1,var10		;"C" eintasten
	ldi	var10,zeichen_A		;	
	sts	anzeige+2,var10		;"A" eintasten
	ldi	var10,zeichen_S		;	
	sts	anzeige+3,var10		;"S" eintasten
	sts	anzeige+4,var10		;"S" eintasten
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "CALC" im anzeige bereithalten					**********
;**********	benutzte Register: var1[1:0], anzeige[4:0], blinkermaske			**********
;*********************************************************************************************************
zeige_calc:
	sts	anzeige,null		;Meldung schreiben
	ldi	var10,zeichen_C		;
	sts	anzeige+1,var10		;"C" eintasten
	ldi	var10,zeichen_A		;
	sts	anzeige+2,var10		;"A" eintasten
	ldi	var10,zeichen_L		;
	sts	anzeige+3,var10		;"L" eintasten
	ldi	var10,zeichen_C		;
	sts	anzeige+4,var10		;"C" eintasten
	lds	var10,blinkermaske	;sichern (Flag "Dimmer_sync" nicht anfassen)
	ori	var10,alle_digits|(1<<dimmer_ein)
	sts	blinkermaske,var10	;alle Stellen sollen dimmen
	sts	taster_dauer,null	;Tasterkommandos lang und kurz gesperrt halten
	sts	zeiger_zeichen,null	;Lauftext auf Anfang stellen
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Zeichenfolge "-----" mit Dezimalpunkten in anzeige schreiben.			**********
;**********	benutzte Register: var1[1:0], anzeige[4:0]					**********
;*********************************************************************************************************
;zeige_leer:				;z.Zt. ungenutzt
;	ldi	var10,(1<<1)|(1<<3)	;Dezimalpunkte "-.--.--" setzen
;	rjmp	zeige_minus		;
zeige_fast_leer:
	ldi	var10,(1<<3)		;Dezimalpunkt "---.--" setzen
;	rjmp	zeige_minus		;
;zeige_ganz_leer:			;z.Zt. ungenutzt
;	ldi	var10,0			;keine Dezimalpunkte "-----" setzen
;zeige_minus:
	ldi	var11,zeichen_minus	;den Rest mit Minuszeichen auffllen
	sts	anzeige,var11		;
	sts	anzeige+1,var11		;
	sts	anzeige+2,var11		;
	sts	anzeige+3,var11		;
	sts	anzeige+4,var11		;
	rcall	setze_dezimalpunkte	;
	rjmp	ende_displaybild	;

;*********************************************************************************************************
;**********	Scrollenden Text in den anzeige schreiben					**********
;**********	benutzte Register: var1[2:0], var2[1:0], Z, anzeige[4:0]			**********
;*********************************************************************************************************
zeige_text:
	lds	var10,kennung		;in "Kennung" wird das Scrollintervall jedes Frame runtergezhlt
	cpi	var10,scrollintervall	;und damit die Laufgeschwindigkeit des Textes eingestellt
	brsh	naechster_buchstabe	;
	rjmp	ende_displaybild	;
naechster_buchstabe:
	sts	kennung,null		;Wartezeit bis zum nchstes Textlauf initialisieren
	clr	var11			;Schleifenzhler fr Digitbeschickung initialisieren

	ldi	zl,byte1(string<<1)	;Z auf Zeichenkette
	ldi	zh,byte2(string<<1)	;
	lds	var10,zeiger_zeichen	;
	add	zl,var10		;Z zeigt jetzt auf aktuelles ASCII-Zeichen
	adc	zh,null			;
erstes_zeichen:
	lpm	var12,z			;
	tst	var12			;Ende der Zeichenkette ist bei 0 erreicht
	brne	gueltiges_zeichen	;
	ldi	zl,byte1(string<<1)	;ja, Z auf Anfang Zeichenkette stellen
	ldi	zh,byte2(string<<1)	;
	sts	zeiger_zeichen,null	;hier auch rcksetzen
	clr	var10			;
	rjmp	erstes_zeichen		;
gueltiges_zeichen:
	inc	var10			;auf nchstes Textzeichen verweisen
	sts	zeiger_zeichen,var10	;
schleife_lauftext:
	lpm	var10,z+		;ASCII-Zeichen holen

	mov	var20,zl		;Z sichern
	mov	var21,zh		;

	tst	var10			;Textende erreicht?
	brne	kein_textende		;

	ldi	zl,byte1(string<<1)	;dann Z auf Beginn Zeichenkette
	ldi	zh,byte2(string<<1)	;
	rjmp	schleife_lauftext	;und erstes Textzeichen holen
kein_textende:
	ldi	zl,byte1(tab_zeichen<<1);Z fr Leuchtzeichentabelle initialisieren
	ldi	zh,byte2(tab_zeichen<<1);
	add	zl,var10		;ASCII-Index dazu
	adc	zh,null			;
	lpm	var10,z			;Leuchtzeichen holen

	ldi	zl,byte1(anzeige)	;Z fr anzeige initialisieren
	ldi	zh,byte2(anzeige)	;
	add	zl,var11		;
	adc	zh,null			;
	st	z,var10			;Leuchtzeichen ablegen

	inc	var11			;
	mov	zl,var20		;Z wiederherstellen
	mov	zh,var21		;
	cpi	var11,5			;schon alle Anzeigestellen bedient?
	brlo	schleife_lauftext	;
	rjmp	ende_displaybild	;

;**********************************************************************************************************
;**********	Behandlung fhrender Nullen							***********
;**********	Jedes Ziffernbild ungleich "Null ohne Dezimalpunkt" wird dargestellt und 	***********
;**********	beendet die nach rechts folgende Nullunterdrckung.				***********
;**********	Auf dem rechten Digit (digits+4) wird nie Nullunterdrckung angewandt		***********
;**********	Benutzte Register: var10, anzeige[3:0]						*********** 
;**********************************************************************************************************
behandle_nullen:
	sbrs	flags2,nullunterdr	;wenn Nullunterdrckung vom Benutzer gewnscht
	rjmp	ende_behandle_nullen	;
	lds	var10,anzeige		;hole linkes Leuchtmuster
	cpi	var10,zeichen_0		;wenn "Null ohne Dezimalpunkt"
	brne	ende_behandle_nullen	;
	sts	anzeige,null		;bitte unterdrcken
	lds	var10,anzeige+1		;hole zweites Leuchtmuster
	cpi	var10,zeichen_0		;wenn "Null ohne Dezimalpunkt"
	brne	ende_behandle_nullen	;
	sts	anzeige+1,null		;bitte unterdrcken
	lds	var10,anzeige+2		;hole drittes Leuchtmuster
	cpi	var10,zeichen_0		;wenn "Null ohne Dezimalpunkt"
	brne	ende_behandle_nullen	;
	sts	anzeige+2,null		;bitte unterdrcken
	lds	var10,anzeige+3		;hole viertes Leuchtmuster
	cpi	var10,zeichen_0		;wenn "Null ohne Dezimalpunkt"
	brne	ende_behandle_nullen	;
	sts	anzeige+3,null		;bitte unterdrcken
ende_behandle_nullen:
	ret

;*********************************************************************************************************
;**********	Behandlung Dezimalpunkt								**********
;**********	benutzte Register: var1[1:0], anzeige[4:0]					**********
;*********************************************************************************************************
setze_dezimalpunkte:
	lds	var11,anzeige		;hole Digit 1
	sbrc	var10,1			;wenn angefordert
	sbr	var11,zeichen_punkt	;Dezimalpunkt eintasten
	sts	anzeige,var11		;

	lds	var11,anzeige+1		;hole Digit 2
	sbrc	var10,2			;wenn angefordert
	sbr	var11,zeichen_punkt	;Dezimalpunkt eintasten
	sts	anzeige+1,var11		;

	lds	var11,anzeige+2		;hole Digit 3
	sbrc	var10,3			;wenn angefordert
	sbr	var11,zeichen_punkt	;Dezimalpunkt eintasten
	sts	anzeige+2,var11		;

	lds	var11,anzeige+3		;hole Digit 4
	sbrc	var10,4			;wenn angefordert
	sbr	var11,zeichen_punkt	;Dezimalpunkt eintasten
	sts	anzeige+3,var11		;

	lds	var11,anzeige+4		;hole Digit 5
	sbrc	var10,5			;wenn angefordert
	sbr	var11,zeichen_punkt	;Dezimalpunkt eintasten

	sbrs	flags,synchron		;wenn synchron
	rjmp	ende_digit_5		;
	sbrs	flags2,calcanzeige	;und keine "CALC"-Anzeigeoption gewhlt
	sbr	var11,zeichen_punkt	;Dezimalpunkt eintasten
ende_digit_5:
	sts	anzeige+4,var11		;
ende_setze_dezimalpunkt:
	ret
