;*********************************************************************************************************
;**********	konstante Daten zum Tapetimer Version 2.1					**********
;*********************************************************************************************************
;**********	Tabelle fr Drehencoder								**********
;*********************************************************************************************************
tab_geber:		;Tabelle mit Drehgeber-Werten (alt-alt-neu-neu als Index) und den
			;Pegelnderungen Geber A und B low und high
			; Tabellenwerte:
			; 0 keine Bewegung
			; 1 ein Schritt vorwrts
			;-1 ein Schritt rckwrts
			; 2 Beginn Weissfeld A
			; 3 Ende   Weissfeld A 
;**********	zur nderung der Drehrichtung alle 1 gegen -1 tauschen und umgekehrt		***********
;**********	die 2 und 3 nicht durch 0 ersetzen, da diese den Laufwerksherzschlag bedienen	***********
			;alt/alt	neu/neu		Lichtschranke Pegelwechsel
.db     0,2		;00		00
.db     -1,2		;00		10		B l>h
.db     3,0		;01		00		A h>l
.db     3,1		;01		10		A h>l und B l>h
.db     1,2		;10		00		B h>l
.db     0,2		;10		10
.db     3,-1		;11		00		A h>l und B h>l
.db     3,0		;11		10		A h>l

;*********************************************************************************************************
;**********	Zeichenkette fr die Anzeige als Lauftext (max 254 Zeichen Lnge)		**********
;**********	mgliche Buchstaben: A B b C c d E F G H h I i J j L N n O o P q r S t U u Y	**********
;**********	mgliche Zeichen:    0 1 2 3 4 5 6 7 8 9 [ ] "  _ - . , ^ | Leerzeichen	**********
;**********	Zur Darstellung von: ""  ein "m"						**********
;**********			     "2." ein "z"						**********
;**********     "Anfhrungszeichen unten" ein "w"						**********
;**********	"Anfhrungszeichen oben"  ein "W" eingeben					**********
;**********	nicht darstellbare Zeichen werden als Leerzeichen dargestellt			**********
;**********	The quick brown Fox jumpes over the lazy Dog,					**********
;   ELISAbEtH LAESSt dIEtEr noch nicht diE quittEn ESSEN, diE SIE SELbSt AbSoLut GErnE GEGESSEN HAEttE.
;*********************************************************************************************************
string:
.if (Geraet==1)
.db	"    SoFt  z1  tc650 JULI 2020",0	;Lauftext, z = "2."
.endif

.if (Geraet==2)
.db	"    SoFt  z1  tc750 JULI 2020",0	;Lauftext, z = "2."
.endif

.if (Geraet==3)
.db	"    SoFt  z1  JULI 2020",0,0		;Lauftext, z = "2."
.endif

.org (PC+0x7f) & 0xff80			;damit beginnt jede folgende Tabelle an einer 256 Byte-Grenze

;*********************************************************************************************************
;**********	Dem Eingangswert Sollhelligkeit 0 bis 255 wird ein PWM-Wert zugewiesen		**********
;**********			quadratisch y = (x^2)/500 + x/2,26 + 12				**********
;**********	Keine Werte < 12, sonst kommt die t2ocm-isr (Helligkeitsabriegelung) bevor die	**********
;**********	laufende t2ovf-isr abgearbeitet ist. Das gibt unsauberes Dimmen.		**********
;**********	Quadratische Gleichung anhand 3 Sttzstellen rechnen und Graphen ansehen:	**********
;**********	https://www.arndt-bruenner.de/mathe/10/parabeldurchdreipunkte.htm		**********
;*********************************************************************************************************
tab_helligkeit:
.db	12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19				;0
.db	20,20,21,21,22,22,23,23,24,24,25,25,26,27,27,28				;16
.db	28,29,29,30,31,31,32,32,33,34,34,35,35,36,37,37				;32
.db	38,38,39,40,40,41,42,42,43,44,44,45,46,46,47,48				;48
.db	49,49,50,51,51,52,53,53,54,55,56,56,57,58,59,59				;64
.db	60,61,62,63,63,64,65,66,66,67,68,69,70,70,71,72				;80
.db	73,74,75,75,76,77,78,79,80,81,81,82,83,84,85,86				;96
.db	87,88,88,89,90,91,92,93,94,95,96,97,98,99,100,100			;112
.db	101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116		;128
.db	117,118,119,120,121,122,123,124,125,127,128,129,130,131,132,133		;144
.db	134,135,136,137,138,139,141,142,143,144,145,146,147,148,150,151		;160
.db	152,153,154,155,156,158,159,160,161,162,163,165,166,167,168,169		;176
.db	171,172,173,174,176,177,178,179,180,182,183,184,185,187,188,189		;192
.db	191,192,193,194,196,197,198,200,201,202,204,205,206,207,209,210		;208
.db	211,213,214,216,217,218,220,221,222,224,225,226,228,229,231,232		;224
.db	233,235,236,238,239,240,242,243,245,246,248,249,251,252,253,255		;240

;*********************************************************************************************************
;**********	Dem Eingangswert Abweichung der Zeitanzeige zur errechneten Zeit wird ein	**********
;**********	Korrekturwert in Frames/Sekunde zugewiesen					**********
;**********	Eingangswert: 0 bis 255, Ausgangswert: 0 bis 12					**********
;**********	linear y = x/16 + 0,5 		quadratische Alternative y = (x^2)/600		**********
;*********************************************************************************************************
tab_zeitkorrektur:
.db	0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1				;0
.db	1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2				;16
.db	2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3				;32
.db	3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4				;48
.db	4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5				;64
.db	5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6				;80
.db	6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7				;96
.db	7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8				;112
.db	8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9				;128
.db	9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10			;144
.db	10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11		;160
.db	11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12		;176
.db	12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12		;192
.db	12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12		;208
.db	12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12		;224
.db	12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12		;240

;*********************************************************************************************************
;**********	Zeichenmuster zur Darstellung auf der Siebensegmentanzeige			**********
;**********	ab 0x10 sind mit 7-Segment-Anzeigen darstellbare ASCII-Zeichen abgelegt		**********
;*********************************************************************************************************
tab_zeichen:
.db     Zeichen_0,Zeichen_1,Zeichen_2,Zeichen_3,Zeichen_4,Zeichen_5,Zeichen_6,Zeichen_7		;"01234567"
.db	Zeichen_8,Zeichen_9,Zeichen_A,Zeichen_b_kl,Zeichen_c,Zeichen_d_kl,Zeichen_e,Zeichen_f	;"89AbCdEF"

.db     0,0,0,0,0,0,0,0										;"        "
.db	0,0,0,0,0,0,0,0										;"        "

.db	0,0,(1<<seg_b)|(1<<seg_f),0,0,0,0,(1<<seg_f)						;"  "    "
.db	0,0,0,0,(1<<seg_e),Zeichen_minus,Zeichen_punkt,0					;"    ,-. "

.db     Zeichen_0,Zeichen_1,Zeichen_2,Zeichen_3,Zeichen_4,Zeichen_5,Zeichen_6,Zeichen_7		;"01234567"
.db	Zeichen_8,Zeichen_9,0,0,0,0,0,0								;"89      "

.db	0,Zeichen_A,Zeichen_8,Zeichen_C,0,Zeichen_E,Zeichen_F,Zeichen_G				;" ABC EFG"
.db	Zeichen_H,Zeichen_I,Zeichen_J,0,Zeichen_L,0,Zeichen_N,Zeichen_O				;"HIJ L NO"

.db	Zeichen_P,0,0,Zeichen_S,0,Zeichen_U,0,(1<<seg_b)|(1<<seg_f)				;"P  S U ""
.db	0,Zeichen_Y,0,Zeichen_C,0,(1<<seg_a)|(1<<seg_b)|(1<<seg_c)|(1<<seg_d),(1<<seg_a)|(1<<seg_b)|(1<<seg_f),(1<<seg_d)
												;" Y [ ]^_"
.db	0,0,Zeichen_b_kl,Zeichen_c_kl,Zeichen_d_kl,0,0,0					;"  bcd   "
.db	Zeichen_h_kl,Zeichen_i_kl,Zeichen_j_kl,0,0,Zeichen_mikro,Zeichen_n_kl,Zeichen_o_kl	;"hij  no"

.db	0,Zeichen_q_kl,Zeichen_r_kl,0,Zeichen_t_kl,Zeichen_u_kl,0,(1<<seg_c)|(1<<seg_e)		;".qr tu w"
.db	0,0,zeichen_2|(1<<seg_dp),0,(1<<seg_e)|(1<<seg_f),0,0,0					;"  2. |   "
